﻿using Microsoft.AspNetCore.Mvc;
using PayCRM.DAL;
using PayCRM.Models;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using System.Linq;

namespace PayCRM.Controllers
{
    public class ClientController : Controller
    {
        private ClientRepository clientRepository = null;        

        public ClientController()
        {
            clientRepository = new ClientRepository(); 
        }

        public IActionResult Index()
        {
            var clients = clientRepository.GetAll().ToList();
            ViewBag.DataSource = clients;            
            return View();
        }

        public ActionResult GetDetailData([FromBody]DataManager value)
        {
            // TODO: Retrieve detail data for the currently selected client.
            IEnumerable Data = null;
            var outres = Json(new { result = Data });
            return outres;
        }

        #region Client grid methods
        public ActionResult InsertClient([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Add(obj.Value);
            return Json(obj.Value);
        }

        public ActionResult UpdateClient([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Update(obj.Value._id, obj.Value);
            return Json(obj.Value);
        }

        public ActionResult DeleteClient([FromBody]CRUDModel<ClientModel> obj)
        {            
            clientRepository.Delete(obj.Key.ToString());
            return Json(obj);
        }
        #endregion

        #region Date grid methods
        public ActionResult InsertDate([FromBody]CRUDModel<ClientModel> obj)
        {
            // Add important clientRepository.AddImportantDate(obj.Value);
            return Json(obj.Value);
        }

        public ActionResult UpdateDate([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Update(obj.Value._id, obj.Value);
            return Json(obj.Value);
        }

        public ActionResult DeleteDate([FromBody]CRUDModel<ClientModel> obj)
        {            
            clientRepository.Delete(obj.Key.ToString());
            return Json(obj);
        }
        #endregion
    }
}
